/*
 * ftpd/normalize.c
 *
 *	A very simple and basic ftp daemon. This file contains a
 *	function to normalize file system path names.
 */

#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/param.h>
#include <assert.h>

#include "ftpd.h"

char *normalize(const char *path)
{
    int i, pathc, newc;
    char *pathv[MAXPATHLEN];
    char *newv[MAXPATHLEN];
    char buffer[MAXPATHLEN];
    char result[MAXPATHLEN];
    char *word;

    assert(path);

    if (strlen(path) > MAXPATHLEN) {
	return NULL;
    }

    strncpy(buffer, path, sizeof(buffer));
    for (pathc = 0, word = strtok(buffer, "/");
	 word; word = strtok(NULL, "/"), pathc++) {
	pathv[pathc] = word;
    }

    for (i = 0, newc = 0; i < pathc; i++) {
	if (strlen(pathv[i]) == 0 && !newc) {
	    newv[0]="/", newc = 1;
	} else if (strcmp(pathv[i], ".") == 0 && newc) {
	    /* do nothing */
	} else if (strcmp(pathv[i], "..") == 0) {
	    if (newc) newc--;
	} else {
	    newv[newc++] = pathv[i];
	}
    }

    for (i = 0, strcpy(result, "/"); i < newc; i++) {
	if (i) strcat(result, "/");
	strcat(result, newv[i]);
    }

    return strdup(result);
}

#if 0

/*
 * ./normalize ~/../schoenw/.. /tmp /../tmp /../tmp/. /foo/../tmp /foo//../tmp /../.. .. . "" / /foo/bar//baz
 */

int main(int argc, char **argv)
{
    int i;

    for (i = 1; i < argc; i++) {
	printf("'%s' -> '%s'\n", argv[i], normalize(argv[i]));
    }

    return 0;
}
#endif
